! Metodos Numericos y Simulaciones en Astrofisica
! FCEFN - UNSJ, 2010
!
! ejemplo 2
!
! numeros aleatorios - prueba de la funcion intrinseca
! del compilador
!
! distribucion uniforme en [0,1)
!
!
program eje2
implicit none
  integer :: i,j,k,old
  integer, dimension(10) :: arr
  real :: valr
  
! pongo a cero el array
!
  arr=0
  
! inicializo la subrutina que genera numeros aleatorios
!
  call random_seed()
  
! itero j veces
!
  write(*,*)'Ingrese nro. iteraciones: '
  read(*,*)j
  
  do i=1,j
  
! obtengo un numero aleatorio
!
   call random_number(valr)

! lo guardo en un histograma
!
	k=int(valr*10.)+1	
	arr(k)=arr(k)+1
  enddo
  
! encuentro el bin con el mayor valor
!
  old=-12
  k=0
  do i=1,10
    if(arr(i) > old)then
	  old=arr(i)
	  k=i
	endif
  enddo
  
! muestro el resultado
!
  do i=1,10
    write(*,*)i,arr(i),float(arr(i))/float(arr(k))
  enddo
! mayor numero entero representable
!
  write(*,*)huge(j)
  
end program eje2